//================================================================================
// zSoundPlayer.
//================================================================================
class zSoundPlayer extends UBrowserConsole Config(zSoundPlayer);

#exec AUDIO IMPORT FILE="Sounds\zzoom.WAV" NAME="zoom" GROUP="zoom"
const anzTxts=32;
struct ExecTextFile
{
	var config string SoundFileName;
	var config string Description;
};

var sound zzoom;

var int SelectedTxt;
var int LastTxt;
var bool bShowTList;
var(TextFiles) config localized ExecTextFile SoundFile[32];
var Font WhiteFont;
var Color GreenSmooth;
var Color RedSmooth;

event bool KeyEvent (EInputKey Key, EInputAction Action, float Delta)
{
	if ( Action != IST_Press )
	{
		return False;
	}
	else
	{
		if ( Key == IK_Tilde )
		{
			if ( ConsoleDest == 0.00 )
			{
				if ( bLocked )
				{
					return True;
				}
				bQuickKeyEnable=True;
				LaunchUWindow();
				if (  !bShowConsole )
				{
					ShowConsole();
				}
				return True;
			}
			else
			{
				GotoState('None');
			}
			return True;
		}
		else
		{
			return False;
		}
	}
}

state UWindow
{
	event Tick (float Delta)
	{
		Super.Tick(Delta);
		if ( Root != None )
		{
			Root.DoTick(Delta);
		}
	}

	event PostRender (Canvas Canvas)
	{
		if ( ConsoleWindow != None )
		{
			UWindowConsoleClientWindow(ConsoleWindow.ClientArea).TextArea.SetPrompt("(> " $ TypedStr);
		}
		if ( Root != None )
		{
			Root.bUWindowActive=True;
		}
		RenderUWindow(Canvas);
	}

	event bool KeyType (EInputKey Key)
	{
		if ( Root != None )
		{
			Root.WindowEvent(WM_KeyType,None,MouseX,MouseY,Key);
		}
		return True;
	}

	event bool KeyEvent (EInputKey Key, EInputAction Action, float Delta)
	{
		local int k;

		k=Key;
		switch (Action)
		{
			case IST_Release:
			switch (Key)
			{
				case IK_LeftMouse:
				if ( Root != None )
				{
					Root.WindowEvent(WM_LMouseUp,None,MouseX,MouseY,k);
				}
				break;
				case IK_RightMouse:
				if ( Root != None )
				{
					Root.WindowEvent(WM_RMouseUp,None,MouseX,MouseY,k);
				}
				break;
				case IK_MiddleMouse:
				if ( Root != None )
				{
					Root.WindowEvent(WM_MMouseUp,None,MouseX,MouseY,k);
				}
				break;
				case UWindowQuickKey:
				if ( bLocked )
				{
					return True;
				}
				CloseUWindow();
				break;
				default:
				if ( Root != None )
				{
					Root.WindowEvent(WM_KeyUp,None,MouseX,MouseY,k);
				}
				break;
			}
			break;
			case IST_Press:
			switch (Key)
			{
				case IK_F9:
				return Global.KeyEvent(Key,Action,Delta);
				break;
				case IK_Tilde:
				if ( bShowConsole )
				{
					HideConsole();
					if ( bQuickKeyEnable )
					{
						CloseUWindow();
					}
				}
				else
				{
					ShowConsole();
				}
				break;
				case IK_Escape:
				if ( Root != None )
				{
					Root.CloseActiveWindow();
				}
				break;
				case IK_LeftMouse:
				if ( Root != None )
				{
					Root.WindowEvent(WM_LMouseDown,None,MouseX,MouseY,k);
				}
				break;
				case IK_RightMouse:
				if ( Root != None )
				{
					Root.WindowEvent(WM_RMouseDown,None,MouseX,MouseY,k);
				}
				break;
				case IK_MiddleMouse:
				if ( Root != None )
				{
					Root.WindowEvent(WM_MMouseDown,None,MouseX,MouseY,k);
				}
				break;
				default:
				if ( Root != None )
				{
					Root.WindowEvent(WM_KeyDown,None,MouseX,MouseY,k);
				}
				break;
			}
			break;
			case IST_Axis:
			switch (Key)
			{
				case IK_MouseX:
				MouseX=MouseX + MouseScale * Delta;
				break;
				case IK_MouseY:
				MouseY=MouseY - MouseScale * Delta;
				break;
				default:
			}
			default:
			break;
		}
		return True;
	}

	function BeginState ()
	{
		Log("Console entering UWindow state");
	}

	function EndState ()
	{
		Log("Console leaving UWindow state");
	}

Begin:
}

simulated function DrawSingleView (Canvas Canvas)
{
	local float fX;
	local float fY;
	local float XPos;
	local float YPos;
	local Color DrawColor;

	Super.DrawSingleView(Canvas);
	if ( bShowTList )
	{
		DrawColor.R=Canvas.DrawColor.R;
		DrawColor.G=Canvas.DrawColor.G;
		DrawColor.B=Canvas.DrawColor.B;
		Canvas.DrawColor.R=255;
		Canvas.DrawColor.G=255;
		Canvas.DrawColor.B=255;

		if ( bShowTList )
			{
				fX=1.00;
				fY=2.50;
				XPos=0.00;
				YPos=64.00;
				DrawDaIcon(Canvas,Texture'TranslatorHUD3',XPos,YPos,fX,fY);
				DrawTxtNames(Canvas,SelectedTxt,fX,fY);
				fX=1.00;
				fY=1.00;
				XPos=0.00;
				YPos=64.00 + 32 + 2.20 * (52 / 2 + 128);
				DrawDaIcon(Canvas,Texture'TranslatorHUD3',XPos,YPos,fX,fY);
				DrawDescription(Canvas,SelectedTxt,XPos,YPos,fX,fY);
			}
		Canvas.DrawColor.R=DrawColor.R;
		Canvas.DrawColor.G=DrawColor.G;
		Canvas.DrawColor.B=DrawColor.B;
	}
}


exec function ShowSounds ()
{
	if ( CountTxts() )
	{
		bShowTList= !bShowTList;
	}
	else
	{
		return;
	}
}

exec function GoDown ()
{
	if (!bShowTList )
	{
		return;
	}
	if ( bShowTList )
		{
			SelectedTxt++;
			if ( SelectedTxt > LastTxt )
			{
				SelectedTxt=0;
			}
		}
		else
		{
			return;
		}
}

exec function GoUp ()
{
	if (  !bShowTList )
	{
		return;
	}

	if ( bShowTList )
		{
			SelectedTxt--;
			if ( SelectedTxt < 0 )
			{
				SelectedTxt=LastTxt;
			}
		}
		else
		{
			return;
		}
}

exec function PlayZSound ()
{
	if (  !bShowTList )
	{
		return;
	}

	if ( bShowTList )
		{
			ExecTxt();
		}
}



function ExecTxt ()
{

    if (  !bShowTList || (SoundFile[SelectedTxt].SoundFileName == "No Text FileName found ! ! !") )
	{
		return;
	}
	ConsoleCommand("Exec " $ SoundFile[SelectedTxt].SoundFileName );
}

function bool CountTxts ()
{
	local int i;

	LastTxt=-1;
	if ( SortTxts() )
	{
		i=0;
JL001B:
		if ( i < 32 )
		{
			if ( SoundFile[i].SoundFileName != "" )
			{
				LastTxt++;
			}
			i++;
			goto JL001B;
		}
		return True;
	}
	else
	{
		return False;
	}
}

function bool SortTxts ()
{
	local int i;
	local int j;

	i=0;
JL0007:
	if ( i < 32 )
	{
		if ( (SoundFile[i].SoundFileName == "") && (SoundFile[i].Description == "") )
		{
			j=i + 1;
JL0051:
			if ( j < 32 )
			{
				if ( (SoundFile[j].SoundFileName == "") && (SoundFile[j].Description != "") )
				{
					SoundFile[j].SoundFileName="No Text FileName found ! ! !";
				}
				else
				{
					if ( (SoundFile[j].SoundFileName != "") && (SoundFile[j].Description == "") )
					{
						SoundFile[j].Description="No Description available for SoundFile: " $ SoundFile[j].SoundFileName;
					}
				}
				if ( (SoundFile[j].SoundFileName != "") && (SoundFile[j].Description != "") )
				{
					SoundFile[i].SoundFileName=SoundFile[j].SoundFileName;
					SoundFile[i].Description=SoundFile[j].Description;
					SoundFile[j].SoundFileName="";
					SoundFile[j].Description="";
				}
				else
				{
					j++;
					goto JL0051;
				}
			}
		}
		else
		{
			if ( (SoundFile[i].SoundFileName == "") || (SoundFile[i].Description == "") )
			{
				if ( (SoundFile[i].SoundFileName == "") && (SoundFile[i].Description != "") )
				{
					SoundFile[i].SoundFileName="No Text FileName found ! ! !";
				}
				else
				{
					if ( (SoundFile[i].SoundFileName != "") && (SoundFile[i].Description == "") )
					{
						SoundFile[i].Description="No Description available for SoundFile: " $ SoundFile[i].SoundFileName;
					}
				}
			}
		}
		i++;
		goto JL0007;
	}
	return True;
}


simulated function DrawTxtNames (Canvas Canvas, int i, float fX, float fY)
{
	local int Step;
	local int j;
	local string CurrentName;
	local float XL;
	local float YL;
	local bool bTooLong;
	local int TempX;
	local int TempY;

	Canvas.bCenter=False;
	TempX=Canvas.ClipX;
	TempY=Canvas.ClipY;
	Canvas.Font=WhiteFont;
	Canvas.Style=2;
	Canvas.SetOrigin(fX * 256 - fX * (110 + 128),fY * 52 / 4 + 64 + 4);
	Canvas.TextSize("Stronzo",XL,YL);
	if ( Canvas.ClipX >= 640 )
	{
		Step=8;
	}
	else
	{
		Step=YL;
	}
	Canvas.SetClip(225.00 * fX,110.00 * fY);
	j=0;
JL0122:
	if ( j < 32 )
	{
		if ( SoundFile[j].SoundFileName == SoundFile[i].SoundFileName )
		{
			Canvas.Style=1;
			Canvas.DrawColor=RedSmooth;
		}
		else
		{
			Canvas.Style=2;
			Canvas.DrawColor=GreenSmooth;
		}
		CurrentName=SoundFile[j].SoundFileName;
		Canvas.TextSize(CurrentName,XL,YL);
		if ( XL >= Canvas.ClipX )
		{
			bTooLong=True;
JL01F1:
			if ( bTooLong )
			{
				CurrentName=Mid(CurrentName,0,Len(CurrentName) - 6) $ "...  ";
				Canvas.TextSize(CurrentName,XL,YL);
				bTooLong=XL >= 225 * fX;
				goto JL01F1;
			}
		}
		Canvas.SetPos(0.00,j * Step);
		Canvas.DrawText(CurrentName,False);
		j++;
		goto JL0122;
	}
	Canvas.SetClip(TempX,TempY);
	Canvas.Reset();
	Canvas.SpaceX=0.00;
	Canvas.bNoSmooth=True;
	Canvas.DrawColor.R=255;
	Canvas.DrawColor.G=255;
	Canvas.DrawColor.B=255;
	Canvas.Font=Canvas.SmallFont;
}

simulated function DrawDescription (Canvas Canvas, int i, float XOffset, float YOffset, float fX, float fY)
{
	local string CurrentName;
	local int TempX;
	local int TempY;

	Canvas.bCenter=False;
	Canvas.Font=WhiteFont;
	TempX=Canvas.ClipX;
	TempY=Canvas.ClipY;
	Canvas.DrawColor=RedSmooth;
	CurrentName=SoundFile[i].Description;
	Canvas.SetOrigin(fX * 256 - fX * (110 + 128),YOffset + fY / 4 * 52 + 6);
	Canvas.SetClip(225.00 * fX,110.00 * fY);
	Canvas.SetPos(0.00,0.00);
	Canvas.Style=1;
	Canvas.DrawText(CurrentName,False);
	Canvas.SetClip(TempX,TempY);
	Canvas.Reset();
	Canvas.SpaceX=0.00;
	Canvas.bNoSmooth=True;
	Canvas.DrawColor.R=255;
	Canvas.DrawColor.G=255;
	Canvas.DrawColor.B=255;
	Canvas.Font=Canvas.LargeFont;
	Canvas.ClipX=TempX;
	Canvas.ClipY=TempY;
}

simulated function DrawDaIcon (Canvas Canvas, Texture Tex, int XPos, int YPos, optional float XScale, optional float YScale)
{
	Canvas.SetPos(XPos,YPos);
	Canvas.Style=3;
	if ( (XScale > 0) && (YScale > 0) )
	{
		Canvas.DrawTile(Tex,Tex.USize * XScale,Tex.VSize * YScale,0.00,0.00,Tex.USize,Tex.VSize);
	}
	else
	{
		if ( (XScale > 0) && (YScale == 0) )
		{
			Canvas.DrawTile(Tex,Tex.USize * XScale,Tex.VSize,0.00,0.00,Tex.USize,Tex.VSize);
		}
		else
		{
			if ( (XScale == 0) && (YScale > 0) )
			{
				Canvas.DrawTile(Tex,Tex.USize,Tex.VSize * YScale,0.00,0.00,Tex.USize,Tex.VSize);
			}
			else
			{
				Canvas.DrawIcon(Tex,1.00);
			}
		}
	}
}

defaultproperties
{
				zzoom=Sound'MGO.zoom.zoom'
				WhiteFont=Font'UnrealShare.WhiteFont'
				RedSmooth=(R=160)
}
